import { Component, Input, OnInit, ViewChild } from '@angular/core';
import { IgxDataChartComponent, IgxStackedAreaSeriesComponent, IgxStackedFragmentSeriesComponent, IgxStackedLineSeriesComponent } from 'igniteui-angular-charts';
import { height } from '../../../globals';

@Component({
  selector: 'chart-out',
  templateUrl: './out.component.html',
  styleUrls: ['./out.component.scss']
})
export class OutComponent implements OnInit {
  @Input() brushes:string[];
  @Input() data:any[];
  @Input() filter:any[];
  @Input() scenarios:string[];

  @ViewChild("chart", { static: false }) public chart:IgxDataChartComponent;

  height:number = height - 435;

  ngOnInit(): void {
    console.log(this.data)
    this.populateChart();
  };

  populateChart() {
    if (this.chart && this.chart.series && this.chart.actualSeries.length > 1) {
      this.chart.series.clear();
      let areaSeries: IgxStackedAreaSeriesComponent = this.chart.actualSeries[0] as IgxStackedAreaSeriesComponent,
          lineSeries: IgxStackedLineSeriesComponent = this.chart.actualSeries[1] as IgxStackedLineSeriesComponent;

      areaSeries.series.clear();
      this.scenarios.length > 1 && lineSeries.series.clear();

      this.filter.forEach((f) => {
        let areaFrag: IgxStackedFragmentSeriesComponent = new IgxStackedFragmentSeriesComponent(),
          lineFrag: IgxStackedFragmentSeriesComponent = new IgxStackedFragmentSeriesComponent();

        areaFrag.valueMemberPath = f;
        areaFrag.title = f;
        areaSeries.series.add(areaFrag);
        if (this.scenarios.length > 1) {
          lineFrag.valueMemberPath = f;
          lineFrag.title = f;
          lineFrag.thickness = 5;
          lineSeries.series.add(lineFrag);
        }
      });

      areaSeries.renderSeries(false);
      this.scenarios.length > 1 && lineSeries.renderSeries(false);
    }
  };
};
